using GraphicsManager.Interfaces;
using GraphicsManager.Objects;
using Luski.net.Structures.Public;

namespace Luski.GUI.MainScreen.UI.LuskiControls;

public class UserView : UserControl
{
    private UserView(IRenderObject user, SocketUser u, Role r)
    {
        base.Size = new(244.ScaleInt(), 44.ScaleInt());
        base.BackgroundColor = new(43, 45, 49, 255);
        user.Location = new(8.ScaleInt(), 6.ScaleInt(), 0);
        user.ForceDistanceUpdate(this);
        Label uname = new(Globals.DefaultFont)
        {
            Text = u.DisplayName,
            Color = r.Color.ToColor4()
        };
        uname.Location = new(user.Location.X + user.Size.X + 8.ScaleInt(),
            (user.Location.Y + (user.Size.Y / 2) - (uname.PostiveTrueHeight / 2) - uname.Size.Y + uname.TrueHeight), 0);
        Controls.Add(uname);
        Controls.Add(user);
    }
    
    public static async Task<UserView> Make(SocketUser u, Role r)
    {
        UserView m = new(await u.MakeRct(new(32.ScaleInt()), true), u, r);
        return m;
    }
}