using Luski.Classes;

namespace Luski;

public static class LuskiExperiments
{
    public static List<ExperimentInfo> LuskiExperimentsList = new()
    {
        Parents.MainServer,
        Parents.ThemeEdit,
        new()
        {
            DisplayName = "Server Member List",
            Name = "2023_12_member_list",
            Options = new()
            {
                ServerExperiments.MemberList
            }
        }
    };
    
    public static class Parents
    {
        public static ExperimentInfo MainServer = new()
        {
            DisplayName = "Main Servers",
            Name = "2023_12_main_servers",
            Options = new()
            {
                MainServers.EnableLuskiMainServers,
                MainServers.EnableMainServers,
            }
        };
        public static ExperimentInfo ThemeEdit = new()
        {
            DisplayName = "Theme Editor",
            Name = "2023_12_theme_edit",
            Options = new()
            {
                Settings.Theme,
            }
        };
    }
    
    public static class Settings
    {
        public static readonly ExperimentSelectorInfo Theme = new()
        {
            Name = "Appearance Tab",
            Description = "Adds a tab to edit the theme options.",
        };
    }
        
    public static class MainServers
    {
        public static readonly ExperimentSelectorInfo EnableMainServers = new()
        {
            Name = "Enable Main Servers",
            Description = "Will allow the Luski client to connect to all main servers.",
            RequiresRestart = true,
        };
        public static readonly ExperimentSelectorInfo EnableLuskiMainServers = new()
        {
            Name = "Enable Luski Main Servers",
            Description = "Will force the Luski client to connect to Luski main servers.",
            RequiresRestart = true,
        };
    }
    
    public static class ServerExperiments
    {
        public static readonly ExperimentSelectorInfo MemberList = new()
        {
            Name = "Member List",
            Description = "Adds a list on the side of a chat that shows members.",RequiresRestart = false
        };
    }
}